#include "stdafx.h"
#include "VixarLibrary.h"

//------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------
CDirectMusic::CDirectMusic()
{
	m_pLoader = NULL;
	m_pPerformance = NULL;
	for ( int i = 0; i < MUSIC_MAX; i++ )
	{
		m_pSegment[i] = NULL;
	}
};	

//------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------
CDirectMusic::~CDirectMusic()
{
	DeleteObj();
}

//-----------------------------------------------------------------------------
// Name: DeleteObj
// Desc: mۂ̈̉
//-----------------------------------------------------------------------------
VOID CDirectMusic::DeleteObj()
{
	for ( int i = 0; i < MUSIC_MAX; i++ )
	{
		if ( m_pSegment[i] != NULL )
		{
			m_pPerformance->Stop(m_pSegment[i], NULL, 0, 0);
			m_pSegment[i]->Unload(m_pPerformance);
			SAFE_RELEASE(m_pSegment[i]);
		}
	}
	SAFE_RELEASE(m_pLoader);
	m_pPerformance->CloseDown();
	SAFE_RELEASE(m_pPerformance);

	CoUninitialize();
}

//-----------------------------------------------------------------------------
// Name: Init()
// Desc: [_[AptH[}XAVZTCU[
//-----------------------------------------------------------------------------
HRESULT CDirectMusic::Init()
{
	HRESULT hr = S_OK;

	//COM̏
	CoInitialize(NULL);

	//[_[̍쐬
	hr = CoCreateInstance(CLSID_DirectMusicLoader, NULL, CLSCTX_INPROC, IID_IDirectMusicLoader8, (void**)&m_pLoader);

	//ptH[}X̍쐬
	hr = CoCreateInstance(CLSID_DirectMusicPerformance, NULL, CLSCTX_INPROC, IID_IDirectMusicPerformance8, (void**)&m_pPerformance);

	//ptH[}XƃVZTCU[̏
	hr = m_pPerformance->InitAudio(NULL, NULL, NULL, DMUS_APATH_DYNAMIC_MONO, 64, DMUS_AUDIOF_ALL, NULL);

	return hr;
}

//-----------------------------------------------------------------------------
// Name: fileLoad
// Desc: TEht@C̃[hsB
//-----------------------------------------------------------------------------
bool CDirectMusic::fileLoad(int sound,char* fileName)
{
	char str[256];

	sprintf(str,"%s%s",GetDirectory(),fileName);

	WCHAR wszPath[256];
	MultiByteToWideChar(CP_ACP, 0, str, -1, wszPath, 256);

	//t@C̃[h
	if(FAILED(m_pLoader->LoadObjectFromFile(
		CLSID_DirectMusicSegment,
		IID_IDirectMusicSegment8,
		wszPath,
		(LPVOID*) &m_pSegment[sound]
		)))
	{
		m_pPerformance->CloseDown();
		DeleteObj();

		return false;
	}

	//ohptH[}XɃ_E[h
	m_pSegment[sound]->Download(m_pPerformance);

	return true;
}

//-----------------------------------------------------------------------------
// Name: Play
// Desc: ǂݍ񂾃TEht@C̍Đ
//-----------------------------------------------------------------------------
HRESULT CDirectMusic::Play(int sound,BOOL bRepeats)
{
	HRESULT hr = S_OK;

	if ( m_pPerformance == NULL || m_pSegment[sound] == NULL )
	{
		return E_FAIL;
	}

	//ĐȂ~
	m_pPerformance->Stop(m_pSegment[sound], NULL, 0, 0);

	//s[gH
	if(bRepeats)
	{
		m_pSegment[sound]->SetRepeats(DMUS_SEG_REPEAT_INFINITE);
		m_pSegment[sound]->SetLoopPoints(0,0);
	}
	else
	{
		m_pSegment[sound]->SetRepeats(0);
	}

	//Đ
	if ( m_pPerformance->PlaySegment(m_pSegment[sound], DMUS_SEGF_SECONDARY, 0, NULL) != S_OK )
	{
		//ĐsȂ~
		m_pPerformance->Stop(m_pSegment[sound], NULL, 0, 0);
		return S_FALSE;
	}

	return hr;
}

//-----------------------------------------------------------------------------
// Name: IsPlaying
// Desc: ǂݍ񂾃TEht@CĐH
//-----------------------------------------------------------------------------
HRESULT CDirectMusic::IsPlaying(int sound)
{
	if ( m_pPerformance == NULL || m_pSegment[sound] == NULL )
	{
		return E_FAIL;
	}

	return m_pPerformance->IsPlaying(m_pSegment[sound], NULL);
}

//-----------------------------------------------------------------------------
// Name: Stop
// Desc: t̒~
//-----------------------------------------------------------------------------
HRESULT CDirectMusic::Stop(int sound)
{
	HRESULT hr = S_OK;

	if ( m_pPerformance == NULL || m_pSegment[sound] == NULL )
	{
		return E_FAIL;
	}

	m_pPerformance->Stop(m_pSegment[sound], NULL, 0, 0);

	return hr;
}
